/*
 * File: app/controller/Manager/Configuration.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('installwiz.controller.Manager.Configuration', {
	extend: 'Ext.app.Controller',

	configure: function() {
		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/startwizard/action/start_opmonstats/",
			success: this.successConfigurationHandler__.bind(this),
			failure: this.errorConfigurationHandler__.bind(this)
		});
	},

	successConfigurationHandler__: function(result) {
		var response = Ext.decode(result.responseText);

		return (response && (response.success || response.success === 1))
			? this.trigger__("successConfiguration", response)
			: this.trigger__("failConfiguration", { statusText: response.message });
	},

	errorConfigurationHandler__: function(topic, result) {
		this.trigger__(topic, result);
	},

	/*
		@private
		Trigger all subscribers.
		@param {response} <Object> Response object
	*/
	trigger__: function(handler, result) {
		this.observers.trigger(handler, [result]);
	},

	/*
		@public
		Inserts a function in the pipe.
		@param {f} <(Object -> _)> Only a function that receives a response object as a parameter, its return is irrelevant
	*/
	onSuccess: function(f) {
		this.observers.subscribe("successConfiguration", f);
		return this;
	},

	/*
		@public
		Inserts a function in the pipe.
		@param {f} <(Object -> _)> Only a function that receives a response object as a parameter, its return is irrelevant
	*/
	onFail: function(f) {
		this.observers.subscribe("failConfiguration", f);
		return this;
	},

	/*
		@public
		Inserts a function in the pipe.
		@param {f} <(Object -> _)> Only a function that receives a response object as a parameter, its return is irrelevant
	*/
	changeLanguage: function(lang) {
		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/startwizard/action/change_opmonadmin_language/",
			params: { language: lang },
			success: this.successLanguageHandler__.bind(this)
		});
	},

	successLanguageHandler__: function(result) {
		var response = Ext.decode(result.responseText);
		return this.trigger__("languageSuccess", response);
	},

	/*
		@public
		Inserts a function in the pipe.
		@param {f} <(Object -> _)> Only a function that receives a response object as a parameter, its return is irrelevant
	*/
	onChangeLanguageDone: function(f) {
		this.observers.subscribe("languageSuccess", f);
		return this;
	},

	init: function(application) {
		this.observers =
			new OPObserver(["successConfiguration", "failConfiguration", "languageSuccess"]);
	}

});
