/*
 * File: app/view/Forms/User.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('installwiz.view.Forms.User', {
	extend: 'Ext.form.Panel',
	alias: 'widget.userform',

	requires: [
		'Ext.form.Label',
		'Ext.form.field.Trigger',
		'Ext.toolbar.Toolbar',
		'Ext.form.field.Checkbox'
	],

	header: false,
	title: 'Defina a senha e o e-mail',

	layout: {
		type: 'vbox',
		align: 'stretch',
		defaultMargins: {
			top: 5,
			right: 0,
			bottom: 5,
			left: 0
		},
		padding: 20
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					layout: {
						type: 'hbox',
						align: 'middle'
					},
					items: [
						{
							xtype: 'label',
							width: 105,
							text: Ext.locale.translate('User'),
							listeners: {
								beforerender: {
									fn: me.onLabelBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							flex: 1,
							cls: 'op-input bold',
							itemId: 'user',
							value: 'opmonadmin',
							readOnly: true,
							emptyText: ''
						}
					]
				},
				{
					xtype: 'triggerfield',
					validator: function(value) {
						return installwiz.app.getController("Manager.State").validateEmail(this, value);
					},
					cls: 'op-input',
					itemId: 'email',
					fieldLabel: Ext.locale.translate('E-mail'),
					emptyText: Ext.locale.translate('E-mail'),
					validateBlank: true,
					triggerCls: 'form-none',
					listeners: {
						beforerender: {
							fn: me.onEmailBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'container',
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'triggerfield',
							validator: function(value) {
								return installwiz.app.getController("Manager.State").validatePassword(this, value);
							},
							cls: 'op-input',
							itemId: 'password',
							width: 302.5,
							fieldLabel: Ext.locale.translate('Password'),
							inputType: 'password',
							emptyText: Ext.locale.translate('New Password'),
							triggerCls: 'form-none',
							listeners: {
								beforerender: {
									fn: me.onPasswordBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							width: 20
						},
						{
							xtype: 'triggerfield',
							validator: function(value) {
								return installwiz.app.getController("Manager.State").validateRepassword(this, value);
							},
							cls: 'op-input',
							itemId: 'repassword',
							width: 197.5,
							inputType: 'password',
							emptyText: Ext.locale.translate('Repeat New Password'),
							triggerCls: 'form-none',
							listeners: {
								beforerender: {
									fn: me.onRepasswordBeforeRender,
									scope: me
								}
							}
						}
					]
				},
				{
					xtype: 'container',
					itemId: 'keyBox',
					layout: {
						type: 'hbox',
						align: 'middle'
					},
					items: [
						{
							xtype: 'triggerfield',
							validator: function(value) {
								return installwiz.app.getController("Manager.State").validateToken(this, value);
							},
							flex: 1,
							cls: 'op-input',
							itemId: 'activationkey',
							fieldLabel: Ext.locale.translate('Activation key'),
							emptyText: Ext.locale.translate('Paste here the key sent by email'),
							triggerCls: 'form-none',
							listeners: {
								beforerender: {
									fn: me.onActivationkeyBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'toolbar',
							margin: '0 -7.1 0 0',
							items: [
								{
									xtype: 'label',
									margins: '0 0 0 5',
									cls: 'eulalink',
									html: Ext.locale.translate('Get a new key'),
									itemId: 'getKey',
									listeners: {
										afterrender: {
											fn: me.onGetKeyAfterRender,
											scope: me
										}
									}
								}
							]
						}
					]
				},
				{
					xtype: 'container',
					itemId: 'eulaContainer',
					margin: '25 0 0 0',
					layout: {
						type: 'hbox',
						align: 'middle',
						pack: 'center'
					},
					items: [
						{
							xtype: 'checkboxfield',
							itemId: 'eulaCheckbox',
							fieldLabel: ''
						},
						{
							xtype: 'label',
							margins: '0 0 0 5',
							html: Ext.locale.translate('I accept the %link%EULA terms described here%endlink%'),
							itemId: 'eulaLabel',
							listeners: {
								beforerender: {
									fn: me.onEulaLabelBeforeRender,
									scope: me
								}
							}
						}
					]
				},
				{
					xtype: 'container',
					cls: 'op-error',
					hidden: true,
					itemId: 'errorBox',
					layout: {
						type: 'hbox',
						align: 'middle'
					},
					items: [
						{
							xtype: 'container',
							html: '<i class="fa fa-exclamation-circle" aria-hidden="true"></i>'
						},
						{
							xtype: 'label',
							itemId: 'errorDesc',
							margin: '0 0 0 10'
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onLabelBeforeRender: function(component, eOpts) {
		component.setText((Ext.locale.translate('User')).replace("Usu&aacute;rio", "Usuário") + ":");
		installwiz.app.getController("Translate").onChange(function() {
			component.setText((Ext.locale.translate('User')).replace("Usu&aacute;rio", "Usuário") + ":");
		});
	},

	onEmailBeforeRender: function(component, eOpts) {
		installwiz.app.getController("Translate").onChange(function() {
			component.setFieldLabel(Ext.locale.translate('E-mail'));
		});
	},

	onPasswordBeforeRender: function(component, eOpts) {
		installwiz.app.getController("Translate").onChange(function() {
			component.setFieldLabel(Ext.locale.translate('Password'));
			component.emptyText = Ext.locale.translate('New Password');
			component.applyEmptyText();
		});
	},

	onRepasswordBeforeRender: function(component, eOpts) {
		installwiz.app.getController("Translate").onChange(function() {
			component.emptyText = Ext.locale.translate('Repeat New Password');
			component.applyEmptyText();
		});
	},

	onActivationkeyBeforeRender: function(component, eOpts) {
		installwiz.app.getController("Translate").onChange(function() {
			component.setFieldLabel(Ext.locale.translate('Activation key'));
			component.emptyText = (Ext.locale.translate('Paste here the key sent by email'));//.replace("ativa&#xE7;&#xE3;o", "ativação");
			component.applyEmptyText();
		});
	},

	onGetKeyAfterRender: function(component, eOpts) {
		installwiz.app.getController("Translate").translateLinkGetAnewKey();

		installwiz.app.getController("Translate").onChange(function() {
			installwiz.app.getController("Translate").translateLinkGetAnewKey(Ext.locale.translate('Get a new key'));
		});
	},

	onEulaLabelBeforeRender: function(component, eOpts) {
		var translate = installwiz.app.getController("Translate");
		translate.onChange(function() {
			translate.updateEulaLabel(Ext.locale.translate('I accept the %link%EULA terms described here%endlink%'));
		});
	}

});