Ext.grid.feature.Grouping.override({
	
    onGroupClick: function(view, rowElement, groupName, e) {
	
		if (!this.selectedCheckBoxes) {
			this.selectedCheckBoxes = new Array();	
			this.selectedHeaders = new Array();
		}
		
		if (e.target.nodeName === "INPUT") {
			
			var cbId = "cb_"+groupName;
			var pos = this.selectedCheckBoxes.indexOf(cbId);
			if (pos != -1) {
				this.selectedCheckBoxes.splice(pos,1);
				this.selectedHeaders.splice(pos,1);
				Ext.get(rowElement.id).removeCls("grid-selected-header");
				return false;
			}
			
			this.selectedCheckBoxes.push(cbId);
			this.selectedHeaders.push(rowElement.id);
			Ext.get(rowElement.id).addCls("grid-selected-header");
			return false;
		}
		
		
		this.callOverridden(arguments);
    },
	
	expand: function(groupName, focus, preventSizeCalculation) {
		this.callOverridden(arguments);
		this.recheckCheckBoxes();
	},
	
	collapse: function(groupName, focus, /*private*/ preventSizeCalculation) {
		this.callOverridden(arguments);
		this.recheckCheckBoxes();
	},
	
	recheckCheckBoxes: function() {
		if (this.selectedCheckBoxes) {
			var i;
			var id;
			for(i=0; i<this.selectedCheckBoxes.length; i++) {
				id = this.selectedCheckBoxes[i];
				Ext.get(id).dom.checked = true;
			}
		}
		if (this.selectedHeaders) {
			var i;
			var id;
			for(i=0; i<this.selectedHeaders.length; i++) {
				id = this.selectedHeaders[i];
				Ext.get(id).addCls("grid-selected-header");
			}
		}		

	},
		
	checkAllCheckBoxes: function() {
		var i;
		var el;
		
		this.selectedCheckBoxes = new Array();
		for(i=0; i<this.view.store.data.items.length; i++) {
			el = this.view.store.data.items[i];
			this.selectedCheckBoxes.push("cb_"+el.data.host_name);
		}
		
		this.recheckCheckBoxes();
		
		this.selectedHeaders = new Array();
		var rows = Ext.select("div[id*=gridview]"); //.addCls("grid-selected-header");
		for(i=1; i<rows.elements.length; i++) {
			var row = Ext.get(rows.elements[i].id).addCls("grid-selected-header");
			this.selectedHeaders.push(rows.elements[i].id);
		}
		
	},
	
	
});