(function () {
	
	"use strict";
	
	/*
	*/
	
	window.OPObserver = function(ids) {
		
		var handlers = [].concat(ids || []).reduce(handlerReducer, {});
		
		var trigger = function(id, xs) {
			return (handlers.hasOwnProperty(id) === false)
				? console.warn("ID " + id + " doesnt exists...")
				: handlers[id].reduce
					( function(acc, f) { return f.apply(null, xs); }
					, null // null passed, never touched acc variable
					);
		};
		
		var subscribe = function(id, f) {
			if (typeof f !== "function") return console.warn("Not passing a function to subscribe.");
			if (handlers.hasOwnProperty(id) === false) return console.warn("ID " + id + " doesnt exists...");
			handlers[id].push(f);
		};
		
		function handlerReducer(acc, id) {
			return (acc.hasOwnProperty(id))
				? acc
				: (acc[id] = [], acc);
		}
		
		return {
			trigger: trigger,
			handlers: handlers,
			subscribe: subscribe
		};
	};
	
}) ();
